Ticket #4227 (closed defect: fixed)

Opened 8 years ago

Last modified 8 years ago

アルバム設定変更時に一部の環境でWarningが発生する

Reported by: pnetan Assigned to: kiwa
Priority: minor Milestone: OpenPNE2.14.1
Component: 指定しない Version: 2.14.x
Keywords: Cc:

Description (Last modified by kiwa)

■現象

アルバムの設定変更をすると一部の環境でWarningが発生する。

携帯版の場合、画像の削除・アルバム画像編集・アルバム表紙変更などでもWarningが発生していた。

■再現環境

  • CentOS 4.7
  • PHP 4.3.9
  • Mysql 4.1.22

■原因

以下の関数を使用するとき、引数の指定が足りていなかった。

  • db_album_update_c_album
  • db_image_insert_c_image
  • db_album_image_data_delete

■修正内容

以下のように変更を行い、Warningを出さなくした

db_album_update_c_album
アルバム表紙画像の指定を任意にすることで、アルバム表紙画像を伴わない携帯での設定変更に対応した
db_image_insert_c_image
この関数を使用するdb_image_data_copy でも db_image_insert_c_image に合わせて引数を増やし、表紙画像の変更時に必須の値を指定できるようにした
db_album_image_data_delete
実行時にメンバーIDを指定していなかったものをメンバーIDを指定するよう変更、画像データの削除が正常に行われるようにした

■関連情報

http://sns.openpne.jp/?m=pc&a=page_fh_diary&target_c_diary_id=21251より転記

携帯からアルバムの公開範囲を変更したときに次のようなエラーが出ます。
ただし、公開範囲は変更されます。

これはバグでしょうか?

Warning: Missing argument 5 for db_album_update_c_album(), called in /hogehoge/webapp/modules/ktai/do/h_album_edit_insert_c_album.php on line 47 and defined in /hogehoge/webapp/lib/db/album.php on line 392

Warning: Cannot modify header information - headers already sent by (output started at /hogehoge/webapp/lib/db/album.php:392) in /hogehoge/webapp/

ちなみに、PHPのバージョンはPHP 5.2.10 です。 

Change History

08/10/09 13:14:08 changed by kiwa

  • keywords deleted.
  • summary changed from 携帯からアルバム公開範囲を変更時にWarningが発生する to 携帯からのアルバム公開範囲を変更時に一部の環境でWarningが発生する.
  • description changed.
  • version set to 2.14.x.
  • milestone set to OpenPNE2.14.1.

08/10/09 14:15:57 changed by imamura623

  • description changed.

08/10/09 19:53:47 changed by mogi

以下で修正しました。確認お願いします。

08/10/09 19:54:26 changed by mogi

  • keywords set to 確認中.

08/10/09 20:02:28 changed by mogi

  • description changed.

08/10/09 20:19:01 changed by mogi

  • description changed.

08/11/09 10:54:32 changed by shingo

未定義の変数「$image_filename」がいきなり使用されています。db_album_update_c_album()の定義側で、第5引数に初期値を設定することで「Warning」を回避してみてはどうでしょうか?

08/11/09 10:57:42 changed by kiwa

  • keywords changed from 確認中 to 差し戻し.

08/11/09 15:27:36 changed by mogi

  • owner changed from nobody to mogi.
  • status changed from new to assigned.

08/11/09 16:37:47 changed by kiwa

  • owner changed from mogi to kiwa.
  • status changed from assigned to new.

引き継ぎます

08/11/09 17:21:35 changed by kiwa

  • keywords changed from 差し戻し to 確認中.
  • description changed.

以下のリビジョンで未定義変数の使用からdb_album_update_c_album()にて$image_filenameにデフォルト値を指定する方法に変更しました。

(follow-up: ↓ 14 ) 08/11/09 18:41:37 changed by shingo

  • keywords changed from 確認中 to 差し戻し.
  • 「,」の後ろに半角スペースを入れてください(1行が長すぎる場合はうまく改行して下さい)
    392	function db_album_update_c_album($c_album_id,$subject,$description,$public_flag,$image_filename = null) 
    
  • webapp/modules/pc/do/h_album_cover_edit_insert_c_album.php の変更は別チケットでお願いします。

08/11/09 19:20:53 changed by kiwa

  • summary changed from 携帯からのアルバム公開範囲を変更時に一部の環境でWarningが発生する to 携帯からのアルバム設定変更時に一部の環境でWarningが発生する.

(in reply to: ↑ 12 ) 08/11/09 19:39:08 changed by kiwa

  • keywords changed from 差し戻し to 確認中.

Replying to shingo:

以下のリビジョンで半角スペースを追加しました。

チケットについては、PC・携帯共にアルバム設定変更でWarningが発生していたので、summary/descriptionを変更する形で対応しました。

08/11/09 19:52:44 changed by imamura623

  • keywords changed from 確認中 to 差し戻し.
  • PCでアルバム画像を編集を実施し、画像を変更するとWarningが発生する(画像は変更されている)

08/12/09 12:46:06 changed by kiwa

  • keywords changed from 差し戻し to 確認中.
  • description changed.
  • summary changed from 携帯からのアルバム設定変更時に一部の環境でWarningが発生する to アルバム設定変更時に一部の環境でWarningが発生する.

携帯版にて、アルバムの画像を伴うほぼ全ての箇所でWarningが出ていました。以下のリビジョンで対応しました。

08/12/09 13:43:00 changed by shingo

  • keywords changed from 確認中 to 差し戻し.

変数に置き換える意図が分かりにくいです。981行目で「$c_albumc_member_id?」を使っているのでそれ以前で置き換えるか、もしくはそのまま関数に渡すかのどちらかにしてください。

webapp/lib/mail/sns.php

1005	            $c_member_id = $c_album['c_member_id']; 

08/12/09 14:21:00 changed by kiwa

  • keywords changed from 差し戻し to 確認中.

以下のリビジョンでメンバーIDの指定を $c_album['c_member_id'] に変更しました

08/12/09 18:08:26 changed by shingo

  • keywords changed from 確認中 to 差し戻し.
  • 引数が足りない
    webapp/lib/mail/sns.php
    
    693:            db_image_insert_c_image($filename, $image_data);
    
    742:        db_image_insert_c_image($filename, $image_data);
    
    1002:            db_image_insert_c_image($filename, $image_data);
    

08/12/09 18:44:26 changed by kiwa

  • keywords changed from 差し戻し to 確認中.

以下のリビジョンでdb_image_insert_c_image で引数が足りていなかった箇所を修正しました。

08/12/09 19:06:48 changed by shingo

  • keywords changed from 確認中 to テスト待ち.

確認しました。 #2964 のコードチェックがなされていない為、似たような不具合が無いとは言い切れませんが、 #3828 で確認することとします。

08/14/09 17:20:28 changed by imamura623

  • keywords deleted.
  • status changed from new to closed.
  • resolution set to fixed.

動作テストし問題無いことを確認しました。